commit 3371e7f18df52867b0b88966bd98d3f1eff6f815
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Tue Oct 26 20:51:46 2021

    Fortran: error recovery on initializing invalid derived type array component
    
    gcc/fortran/ChangeLog:
    
            PR fortran/102816
            * resolve.c (resolve_structure_cons): Reject invalid array spec of
            a DT component referenced in a structure constructor.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/102816
            * gfortran.dg/pr102816.f90: New test.
    
    (cherry picked from commit 99af0b2f0fe1c0dc8c6d558157e700326d52816a)

diff --git a/gcc/fortran/resolve.c b/gcc/fortran/resolve.c
index 277af0e61b0..bf7902742e2 100644
--- a/gcc/fortran/resolve.c
+++ b/gcc/fortran/resolve.c
@@ -1463,8 +1463,15 @@ resolve_structure_cons (gfc_expr *expr, int init)
 	  mpz_init (len);
 	  for (int n = 0; n < rank; n++)
 	    {
-	      gcc_assert (comp->as->upper[n]->expr_type == EXPR_CONSTANT
-			  && comp->as->lower[n]->expr_type == EXPR_CONSTANT);
+	      if (comp->as->upper[n]->expr_type != EXPR_CONSTANT
+		  || comp->as->lower[n]->expr_type != EXPR_CONSTANT)
+		{
+		  gfc_error ("Bad array spec of component %qs referenced in "
+			     "structure constructor at %L",
+			     comp->name, &cons->expr->where);
+		  t = false;
+		  break;
+		};
 	      mpz_set_ui (len, 1);
 	      mpz_add (len, len, comp->as->upper[n]->value.integer);
 	      mpz_sub (len, len, comp->as->lower[n]->value.integer);
diff --git a/gcc/testsuite/gfortran.dg/pr102816.f90 b/gcc/testsuite/gfortran.dg/pr102816.f90
new file mode 100644
index 00000000000..46831743b2b
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr102816.f90
@@ -0,0 +1,9 @@
+! { dg-do compile }
+! PR fortran/102816
+
+program p
+  type t
+     integer :: a([2])     ! { dg-error "must be scalar" }
+  end type
+  type(t) :: x = t([3, 4]) ! { dg-error "Bad array spec of component" }
+end

